VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MDIConnector"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"UserDefinedCollection"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
''' Enhanced Menu v2.3

''' Owner-drawn menu control for all Windows editions.
''' MDI window connection

''' Copyright (C) 2000 Nathan Moschkin.
''' All Rights Reserved.

''' Free to copy and distribute, intact.  Give credit to me and anyone else
''' who may edit this code.

''' Please inquire before using any of this code or the DLL control commercially.
''' An OCX version of the menu with added features will be available soon.
''' OCX package coming in Version 3.0

''' E-Mail questions or comments to nmosch@tampabay.rr.com

Option Explicit

''' Private variables that represent public or read-only properties

Private m_hWndClient As Long
Private m_hWndFrame As Long

Private m_OldWndProc As Long
Private m_OldClientWndProc As Long

Private m_Connection As EnhancedMenu
Private m_LastConnection As EnhancedMenu

' Form activate event

Public Event FormActivate(ByVal hwnd As Long)

Public Property Get Connection() As EnhancedMenu
    Set Connection = m_Connection
End Property

Public Property Get LastConnection() As EnhancedMenu
    Set LastConnection = m_LastConnection
    
End Property

Public Property Get hWndFrame() As Long
    hWndFrame = m_hWndFrame
End Property

Public Property Get hWndClient() As Long
    hWndClient = m_hWndClient
End Property

Public Property Get Connected() As Boolean
    On Error Resume Next
    
    If Not m_Connection Is Nothing Then
        Connected = True
    Else
        Connected = False
    End If
    
End Property

Public Sub Disconnect()

    If m_hWndFrame = 0 Then Exit Sub
    
    On Error Resume Next
    
    If Not m_Connection Is Nothing Then
        
        Set m_LastConnection = m_Connection
        
        m_Connection.ReleaseWindowHandle
        
        Set m_Connection.Connection = Nothing
        Set m_Connection = Nothing
        
        g_WindowListHandle = 0
    End If
    
End Sub

Public Sub Connect(varMenu As EnhancedMenu)

    On Error Resume Next
    
    Dim v_hMenu As Long, v_hSubmenu As Long
    
    v_hSubmenu = 0
    
    If m_hWndFrame = 0 Then Exit Sub
    If Not m_Connection Is Nothing Then Disconnect
    
    Set m_Connection = varMenu
    Set varMenu.Connection = Me
    
    varMenu.SetWindowHandle m_hWndFrame
    v_hMenu = varMenu.Handle
        
    If Not varMenu.WindowList Is Nothing Then
        varMenu.WindowList.WindowList = True
        
        v_hSubmenu = varMenu.WindowList.Handle
        g_WindowListHandle = v_hSubmenu
        UpdateListChecks , m_hWndClient
        
    End If
    
    
    g_IsSetting = True
    
    SendMessage m_hWndClient, WM_MDISETMENU, v_hMenu, v_hSubmenu
    SendMessage m_hWndClient, WM_MDIREFRESHMENU, 0, 0
    
    g_IsSetting = False
        
    DrawMenuBar m_hWndFrame
End Sub

Public Sub SetWindowHandle(ByVal hWndFrame As Long)
    On Error Resume Next
    
    m_hWndClient = GetClientWindow(hWndFrame)
    
    If m_hWndClient <> 0 Then
        m_hWndFrame = hWndFrame
            
        If GetOldWndProc(m_hWndFrame) = 0 Then
            
            m_OldWndProc = SetWindowLong(m_hWndFrame, GWL_WNDPROC, AddressOf MenuWndProc)
            AddHandle m_hWndFrame, m_OldWndProc, -1&
            
        End If
            
        If GetOldWndProc(m_hWndClient) = 0 Then
            
            m_OldClientWndProc = SetWindowLong(m_hWndClient, GWL_WNDPROC, AddressOf ClientWndProc)
            AddHandle m_hWndClient, m_OldClientWndProc, -1&
                   
        End If
            
    End If

End Sub

Public Sub ReleaseWindowHandle()

    If m_hWndClient <> 0 Then
    
        SetWindowLong m_hWndClient, GWL_WNDPROC, m_OldClientWndProc
        RemoveHandle m_hWndClient
        m_hWndClient = 0
    
    End If
        
    If m_hWndFrame <> 0 Then
        
        SetWindowLong m_hWndFrame, GWL_WNDPROC, m_OldWndProc
        RemoveHandle m_hWndFrame
        m_hWndFrame = 0
    
    End If
    
End Sub

'' The Destroy method

Public Sub Destroy()
    On Error Resume Next
    
    Disconnect
    ReleaseWindowHandle
    
End Sub

Private Sub Class_Terminate()

    Destroy
    
    Set m_Connection = Nothing
    Set m_LastConnection = Nothing
    
End Sub
