VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"SubMenu"
''' Enhanced Menu v2.3

''' Owner-drawn menu control for all Windows editions.
''' Menu Item object

''' Copyright (C) 2000 Nathan Moschkin.
''' All Rights Reserved.

''' Free to copy and distribute, intact.  Give credit to me and anyone else
''' who may edit this code.

''' Please inquire before using any of this code or the DLL control commercially.
''' An OCX version of the menu with added features will be available soon.

''' E-Mail questions or comments to nmosch@tampabay.rr.com

Option Explicit

''' Private variables that represent public or read-only properties

'' Other objects referenced by this item

Private m_Accel As Accelerator

Private m_Parent As Object

'' Every item has a submenu object whether it is used or not

Private m_Submenu As Submenu

'' Internal structures to keep track of what Windows sees

Private m_ItemInfo As MENUITEMINFO

Private m_LastDraw As DRAWITEMSTRUCT

Private m_DCOrigin As POINTAPI

'' Menu identification

Private m_MenuId As Long

Private m_Key As String

Private m_Caption As String

'' Interface to the item bitmap

Private m_Picture As StdPicture

'' Handle to the item bitmap

Private m_hBmp As OLE_HANDLE

'' Handle to the check bitmap

Private m_CheckBmp As OLE_HANDLE

'' Color of item if selected

Private m_SelectColor As OLE_COLOR

'' Default Font property

Private m_Font As StdFont

'' State values

Private m_svChecked As Long

Private m_svDefault As Long

Private m_svEnabled As Long

Private m_svHighlight As Long

Private m_svBreak As Long

Private m_svRightJustify As Long

'' Boolean properties

Private m_BarBreak As Boolean

Private m_Break As Boolean

Private m_CaptionSeparator As Boolean

Private m_ClearHighlight As Boolean

Private m_ColorSelect As Boolean

Private m_HotTracked As Boolean

Private m_Italic As Boolean

Private m_MonoDefault As Boolean

Private m_RadioGroup As Boolean

Private m_RightJustify As Boolean

Private m_UserEnableState As Boolean

' The ItemSelect event

Public Event ItemSelect(MenuObject As MenuItem)

'' Instructs the object to fire the ItemSelect event if the object is delcared 'WithEvents'
'' This function is called when an item is selected by the window subclassing procedure in
'' the m_EnhancedMenu module.

Friend Sub MenuSelectEvent(ByVal wParam As Long)
    Dim v_Menu As MenuItem, v_EnhMenu As EnhancedMenu, v_Submenu As Submenu
    
    On Error Resume Next
    
    If wParam = m_MenuId Then
        Set v_Menu = Me
    Else
        Set v_Menu = SearchRecursive(m_Submenu, wParam)
    End If
    
    If Not v_Menu Is Nothing Then
            
        If m_Parent Is Nothing Then
            
            RaiseEvent ItemSelect(v_Menu)
        
        Else
            
            If TypeOf m_Parent Is EnhancedMenu Then
                
                Set v_EnhMenu = m_Parent
                v_EnhMenu.MenuSelectEvent wParam
            
            ElseIf TypeOf m_Parent Is Submenu Then
                
                Set v_Submenu = m_Parent
                v_Submenu.MenuSelectEvent wParam
            
            End If
        End If
    
    End If
End Sub

Friend Sub GetLastDraw(m_Draw As DRAWITEMSTRUCT)
    
    CopyMemory m_Draw, m_LastDraw, Len(m_LastDraw)
    
End Sub

Friend Sub SetLastDraw(m_Draw As DRAWITEMSTRUCT)
    
    CopyMemory m_LastDraw, m_Draw, Len(m_LastDraw)
    
End Sub

Friend Sub GetDCOrg(pOrg As POINTAPI)

    CopyMemory pOrg, m_DCOrigin, Len(pOrg)
    
End Sub


Friend Sub SetDCOrg(ByVal hDC As Long)

    GetDCOrgEx hDC, m_DCOrigin

End Sub

''''' PROPERTIES RELATING TO HOW THE ITEM IS DRAWN

' Set this item highlighted without being selected with the mouse or keyboard.
' useful for implementing a non-executing accelerator.

Friend Sub Highlight()

    m_svHighlight = MFS_HILITE
    SetCtrlState True
    
End Sub

' BarBreak and Break properties... splits the menu.

Public Property Get BarBreak() As Boolean
    BarBreak = m_BarBreak
End Property

Public Property Let BarBreak(ByVal v_Data As Boolean)
    m_BarBreak = v_Data
    
    If m_BarBreak Then
        m_BarBreak = False
        m_svBreak = MFT_MENUBARBREAK
    Else
        m_svBreak = 0&
    End If
    
    SetCtrlState
End Property

Public Property Get Break() As Boolean
    Break = m_Break
End Property

Public Property Let Break(ByVal v_Data As Boolean)
    m_Break = v_Data
    
    If m_Break Then
        m_BarBreak = False
        m_svBreak = MFT_MENUBREAK
    Else
        m_svBreak = 0&
    End If
    
    SetCtrlState
End Property

' MonoDefault property.  Makes a picture on the menu monochrome until highlighted
' like the coolbar.

Public Property Get MonoDefault() As Boolean
    MonoDefault = m_MonoDefault
    
End Property

Public Property Let MonoDefault(ByVal vData As Boolean)
    m_MonoDefault = vData
End Property

' Set text = Italic.

Public Property Get Italic() As Boolean
    Italic = m_Italic
End Property

Public Property Let Italic(ByVal vData As Boolean)
    m_Italic = vData
End Property

' Is hot tracked (color+underline, no hilight)

Public Property Get HotTracked() As Boolean
    HotTracked = m_HotTracked
End Property

Public Property Let HotTracked(ByVal vData As Boolean)
    m_HotTracked = vData
    If vData Then
        If (m_SelectColor = 0) Then
            m_SelectColor = GetSysColor(COLOR_ACTIVECAPTION)
        End If
        m_ColorSelect = False
    End If
End Property

' Color select property.

Public Property Let ColorSelect(ByVal vData As Boolean)
    m_ColorSelect = vData
    
    If (vData = True) Then
        If (m_SelectColor = 0) Then
            m_SelectColor = GetSysColor(COLOR_ACTIVECAPTION)
        End If
        m_HotTracked = False
    End If

End Property

Public Property Get ColorSelect() As Boolean
    ColorSelect = m_ColorSelect
End Property

' Hot tracked/ColorSelect item selection color.

Public Property Let SelectColor(ByVal vData As OLE_COLOR)
    m_SelectColor = vData
End Property

Public Property Get SelectColor() As OLE_COLOR
     SelectColor = m_SelectColor
End Property

' Clear highlight - HotLight (not HotTrack) popup menu items
' like menu-bar items.

Public Property Let ClearHighlight(ByVal vData As Boolean)
    m_ClearHighlight = vData
End Property

Public Property Get ClearHighlight() As Boolean
    ClearHighlight = m_ClearHighlight
End Property

' set this item as a default menu item.

Public Property Let Default(ByVal vData As Boolean)
    On Error Resume Next
    
    If m_Parent Is Nothing Then Exit Property
    
    If vData = True Then
        m_svDefault = MFS_DEFAULT
    Else
        m_svDefault = 0
    End If
                
    SetCtrlState
    

End Property

' get the default status.

Public Property Get Default() As Boolean
    ' GetCtrlState
    
    If m_svDefault <> 0 Then
        Default = True
    Else
        Default = False
    End If
    
End Property

' Check / Uncheck the item.

Public Property Get Checked() As Boolean
    ' GetCtrlState
    
    If m_svChecked <> 0 Then
        Checked = True
    Else
        Checked = False
    End If
    
End Property

Public Property Let Checked(ByVal vData As Boolean)
    If vData = True Then
        m_svChecked = MFS_CHECKED
    Else
        m_svChecked = 0
    End If
    
    SetCtrlState
End Property

Public Property Get RightJustify() As Boolean
    RightJustify = m_RightJustify
End Property

Public Property Let RightJustify(ByVal v_Data As Boolean)
    m_RightJustify = v_Data
    
    If m_RightJustify Then
        m_svRightJustify = MFT_RIGHTJUSTIFY
    Else
        m_svRightJustify = 0&
    End If
    
    SetCtrlState
End Property


' Set this item as a radio group item when unchecked (blank checkbox).

Public Property Get RadioGroup() As Boolean
    RadioGroup = m_RadioGroup
    
End Property

Public Property Let RadioGroup(ByVal vData As Boolean)
    m_RadioGroup = vData

End Property

Public Property Get Picture() As StdPicture
    On Error Resume Next
    Set Picture = m_Picture
End Property

''' Set the bitmap of the image.
''' bitmap can be an icon.

Public Property Set Picture(vData As StdPicture)
    On Error Resume Next
    
    Set m_Picture = vData
    SetCtrlState

End Property

' Font property

Public Property Get Font() As StdFont

    Set Font = m_Font
    
End Property

Public Property Set Font(IFont As StdFont)

    Set m_Font = IFont
    Set m_Submenu.Font = IFont
    
    If TypeOf m_Parent Is EnhancedMenu Then
        DrawMenuBar m_Parent.hwnd
    End If
    
End Property

''' The caption is the text displayed in the menu

Public Property Get Caption() As String
Attribute Caption.VB_UserMemId = 0
Attribute Caption.VB_MemberFlags = "200"
    ' GetCtrlState
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal vData As String)
    Dim x As Integer, v As String
        
    x = GetAccelPos(vData)
    If x > 0 Then
        v = Mid(vData, x + 1, 1)
        m_Accel.Selector = UCase(v)
    End If
    
    m_Caption = vData
    
    ' m_svHighlight = 0
    
    SetCtrlState
        
End Property

Public Property Get CaptionSeparator() As Boolean
    ' GetCtrlState
    
    CaptionSeparator = m_CaptionSeparator
    
End Property

' If the item is currently selected.

Public Property Get Highlighted() As Boolean
    If Not m_svHighlight Then
        Highlighted = False
    Else
        Highlighted = True
    End If
End Property

Public Property Let CaptionSeparator(ByVal vData As Boolean)
    m_CaptionSeparator = vData
    SetCtrlState
End Property

'''

''' Properties relating to identification and functionality.
'''

''' External interface to an items Enabled/Disabled properties

Public Property Let Enabled(ByVal vData As Boolean)
    
    m_UserEnableState = vData
    
    If (vData = True) And (m_CaptionSeparator = False) Then
        m_svEnabled = MFS_ENABLED
    Else
        m_svEnabled = MFS_DISABLED
    End If
    
    SetCtrlState
    
End Property

Public Property Get Enabled() As Boolean
            
    Enabled = m_UserEnableState
    
End Property


''' The MenuId is assigned when the menu object is created, but
''' re-assigned when a menu is added to the collection.
''' The GetNewCtrlId function generates a CtrlID at the top most level
''' of the menu heirarchy.

Public Property Get MenuId() As Long
    MenuId = m_MenuId
    
End Property

Friend Property Let MenuId(ByVal vData As Long)
    m_MenuId = vData
    m_Submenu.MenuId = vData
    m_ItemInfo.wID = vData
    ' SetCtrlState
End Property
        
''' The Key of the object

Public Property Let Key(ByVal vData As String)
    m_Key = vData
End Property

Public Property Get Key() As String
    Key = m_Key
End Property

''' Properties relating to parent and child objects
'''

' Parent property (can be a submenu or enhanced menu)

Friend Property Set Parent(vData As Object)
    On Error Resume Next
    
    If (TypeOf m_Parent Is EnhancedMenu) Or (TypeOf m_Parent Is Submenu) Then
        
        Set m_Parent = vData
        Set m_Submenu.Parent = vData
        
        m_ItemInfo.dwTypeData = m_Parent.Handle
        
        Set m_Accel.Tabl = m_Parent.Accelerators
        
    End If
    
End Property

Public Property Get Parent() As Object
    Set Parent = m_Parent
End Property

' Submenu property

Public Property Get Submenu() As Submenu
    Set Submenu = m_Submenu
End Property

Friend Property Set Submenu(vData As Submenu)
    On Error Resume Next
    If Not vData Is Nothing Then
        Set m_Submenu = vData
    End If
    
End Property

' Property to get the top-most parent on the menu tree

Public Property Get SuperParent() As Object
    On Error Resume Next

    If Not m_Parent Is Nothing Then
        Set SuperParent = m_Parent.SuperParent
    End If
    
End Property

'''

''' Accelerator object property

Public Property Get Accelerator() As Accelerator
    On Error Resume Next
    
    Set Accelerator = m_Accel
End Property

    ' The search function will read the whole data collection.
    ' If it is textual, then it will search every menu and every
    ' Submenu of every menu and so forth looking for a matching key.
    ' If it's an integer value, then we assume, that it refers directly to the
    ' MenuId assigned by the GetCtrlID function in EnhancedMenu

Public Function Search(ByVal varIndexKey As Variant) As MenuItem
    
    ''' See SearchRecursive method in m_EnhancedMenu
    Set Search = SearchRecursive(m_Submenu, varIndexKey)

End Function
   
''' Centralized functions for setting and getting certain aspects of a menu
''' item's control state such as the Enabled and Default properties.

' refresh the physical control from data stored in the object.

Public Sub SetCtrlState(Optional ByVal WithHighlight As Boolean = False)
    On Error Resume Next
    
    ''' if there is no parent, this menu item does not exist.
    
    If m_Parent Is Nothing Then Exit Sub
    
    ''' Set the caption along with the state
    
    If Not WithHighlight Then
        m_svHighlight = 0
    End If
        
    If ((m_CaptionSeparator = True) And (m_Submenu.Count = 0)) Or (m_UserEnableState = False) Then
        m_svEnabled = MFS_DISABLED
    Else
        m_svEnabled = MFS_ENABLED
    End If
        
    m_ItemInfo.fState = m_svEnabled + m_svDefault + m_svChecked + m_svHighlight
    
    ' SetMenuItemInfo m_Parent.Handle, m_MenuId, False, m_ItemInfo
    If Not WithHighlight Then
        m_ItemInfo.fMask = MIIM_STATE + MIIM_TYPE
    Else
        m_ItemInfo.fMask = MIIM_STATE
        SetMenuItemInfo m_Parent.Handle, m_MenuId, False, m_ItemInfo
        Exit Sub
    End If
    
    If m_Caption <> "-" Then
        
        If m_svBreak Then
            m_ItemInfo.fType = m_svBreak
        Else
            m_ItemInfo.fType = MFT_OWNERDRAW + m_svRightJustify
        End If
        
        m_ItemInfo.dwTypeData = SuperParent.Handle
    Else
        m_ItemInfo.fType = MFT_SEPARATOR
    End If
    
    m_Submenu.SetItemInfo m_ItemInfo
    SetMenuItemInfo m_Parent.Handle, m_MenuId, False, m_ItemInfo
    
    If m_svDefault Then
        SetMenuDefaultItem m_Parent.Handle, m_MenuId, 0
    End If
    
    GetCtrlState
    
End Sub

' Refresh the state of the control object with that of the physical menu's.

Public Sub GetCtrlState()
    On Error Resume Next
    
    ''' if there is no parent, this menu item does not exist.
        
    If m_Parent Is Nothing Then Exit Sub
    
    m_ItemInfo.fMask = MIIM_STATE + MIIM_TYPE
    
    GetMenuItemInfo m_Parent.Handle, m_MenuId, False, m_ItemInfo
    m_Submenu.SetItemInfo m_ItemInfo
    ''' Disabled/Enabled state
    
    If m_ItemInfo.fState And MFS_HILITE Then
        m_svHighlight = MFS_HILITE
    Else
        m_svHighlight = 0
    End If
    
    If m_ItemInfo.fState And MFS_DISABLED Then
        m_svEnabled = MFS_DISABLED
    ElseIf m_ItemInfo.fState And MFS_ENABLED Then
        m_svEnabled = MFS_ENABLED
    End If
    
    ''' Default/Bold state
    
    If m_ItemInfo.fState And MFS_DEFAULT Then
        m_svDefault = MFS_DEFAULT
    Else
        m_svDefault = 0
    End If
    
    If m_ItemInfo.fState And MFS_CHECKED Then
        m_svChecked = MFS_CHECKED
    Else
        m_svChecked = 0
    End If

    If m_ItemInfo.fType And MFT_RIGHTJUSTIFY Then
        m_svRightJustify = MFT_RIGHTJUSTIFY
    Else
        m_svRightJustify = 0&
    End If
    
    If m_ItemInfo.fType And (MFT_MENUBREAK + MFT_MENUBARBREAK) Then
    
        If m_ItemInfo.fType And MFT_MENUBREAK Then
            m_svBreak = MFT_MENUBREAK
            m_Break = True
            m_BarBreak = False
        Else
            m_svBreak = MFT_MENUBARBREAK
            m_BarBreak = True
            m_Break = False
        End If
    
    End If
        
    m_ItemInfo.fMask = MIIM_CHECKMARKS
    
    GetMenuItemInfo m_Parent.Handle, m_MenuId, False, m_ItemInfo
    
    m_CheckBmp = m_ItemInfo.hbmpChecked
    
    If (m_CaptionSeparator = True) And (m_UserEnableState = True) Then
        m_svEnabled = MFS_ENABLED
    End If
    
End Sub

'' Destroy is called internally by the Class_Terminate Method
'' Destroy is also called externally by EnhancedMenu and Submenu Destroy() methods

Friend Sub Destroy()
    
    m_Submenu.Destroy
    DeleteMenu m_Parent.Handle, m_MenuId, 0
    
End Sub

'' Private Subroutines called when an instance is created or destroyed

' Initialize default values of the function, assign a default
' menu id, and set the ItemInfo structure length according to the OS version

Private Sub Class_Initialize()
    On Error Resume Next
        
    m_MenuId = GetNewCtrlId
            
    m_ItemInfo.cbSize = g_InfoSize
    
    Select Case g_WinVersion
    
        Case Windows2000, WindowsME:
            m_SelectColor = GetSysColor(COLOR_HOTLIGHT)
        
        Case Else
            m_SelectColor = GetSysColor(COLOR_HIGHLIGHT)
    
    End Select
            
    Set m_Submenu = New Submenu
    
    Set m_Accel = New Accelerator
        
    Set m_Submenu.ParentItem = Me
    Set m_Submenu.Parent = m_Parent
    
    m_Submenu.MenuId = m_MenuId
    
    m_Accel.Cmd = m_MenuId
    
    m_ItemInfo.wID = m_MenuId
    m_ItemInfo.dwTypeData = m_MenuId
    
    m_svEnabled = 0
    m_svDefault = 0
    
    m_UserEnableState = True
    
End Sub

''' Automatically destroy the whole thing on terminate.

Private Sub Class_Terminate()
    
    Destroy
    Set m_Submenu = Nothing
    
End Sub


