VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SubMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"MenuItem"
Attribute VB_Ext_KEY = "Member0" ,"MenuItem"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
''' Enhanced Menu v2.3

''' Owner-drawn menu control for all Windows editions.
''' Popup/dropdown/sub-menu object.

''' Copyright (C) 2000 Nathan Moschkin.
''' All Rights Reserved.

''' Free to copy and distribute, intact.  Give credit to me and anyone else
''' who may edit this code.

''' Please inquire before using any of this code or the DLL control commercially.
''' An OCX version of the menu with added features will be available soon.

''' E-Mail questions or comments to nmosch@tampabay.rr.com

Option Explicit

''' Private variables that represent public or read-only properties

'' Identification

Private m_Key As String

Private m_MenuId As Long

Private m_WindowList As Boolean

'' Handle

Private m_hMenu As Long

'' Information about this menu stored in Win32 standard format

Private m_ItemInfo As MENUITEMINFO

'' Collection to store child items

Private m_Col As Collection

'' Accelerator collection

Private m_Accel As AccelCol

'' Default Font property

Private m_Font As StdFont

'' Parent objects

'' Parent item (can be nothing, for when a Submenu object is a Submenu, and not just a popup menu)

Private m_Item As MenuItem
Private m_Parent As Object

' The ItemSelect event

Public Event ItemSelect(MenuObject As MenuItem)

''' Menu-related properties
'''

' Menu handle

Public Property Get Handle() As Long
    Handle = m_hMenu
End Property

''' The Subclass method may need to set this variable externally

Friend Property Let Handle(ByVal vData As Long)
    
    On Error Resume Next
    
    If m_hMenu <> 0 Then Destroy
    
    m_hMenu = vData
    
    If m_hMenu <> 0 Then
        If Not g_MenuCol("H" + Hex(m_hMenu)) Is Nothing Then
            g_MenuCol.Remove "H" + Hex(m_hMenu)
        End If
        
        g_MenuCol.Add Me, "H" + Hex(m_hMenu)
    End If
    
End Property

'' Key property

Public Property Get Key() As String
    Key = m_Key
End Property

Public Property Let Key(v_Str As String)
    m_Key = v_Str
End Property

''' The Menu ID is assigned when the menu object is created, but
''' re-assigned when a menu is added to the collection.
''' The GetNewCtrlId function generates a CtrlID at the top most level
''' of the menu heirarchy.

Friend Property Let MenuId(ByVal vData As Long)
    m_MenuId = vData
    m_ItemInfo.wID = vData
    
End Property

Public Property Get MenuId() As Long
    MenuId = m_MenuId
End Property

''' Properties relating to the object's parent object(s).
'''

' Parent object (Submenu or EnhancedMenu)

Public Property Get Parent() As Object
    Set Parent = m_Parent
End Property

' Font property

Public Property Get Font() As StdFont

    Set Font = m_Font
    
End Property

Public Property Set Font(IFont As StdFont)

    Set m_Font = IFont
    If TypeOf m_Parent Is EnhancedMenu Then
        DrawMenuBar m_Parent.hwnd
    End If
    
End Property

' The parent property is set only by member functions and objects

Friend Property Set Parent(vData As Object)
    On Error Resume Next
    
    If Not vData Is Nothing Then
        If (TypeOf vData Is EnhancedMenu) Or (TypeOf vData Is Submenu) Then
            Set m_Parent = vData
            Set m_Font = m_Parent.Font
        End If
    End If
End Property

' The superparent is the top-most object in the menu tree

Public Property Get SuperParent() As Object
    On Error Resume Next

    If m_Parent Is Nothing Then
        Set SuperParent = Me
    Else
        Set SuperParent = m_Parent.SuperParent
    End If

End Property

' Gets the MenuItem object (if any) that is associated with this Submenu

Public Property Get ParentItem() As MenuItem
    Set ParentItem = m_Item
End Property

Friend Property Set ParentItem(vData As MenuItem)
    Set m_Item = vData
End Property

'''

' WindowList property (boolean), for MDI forms

Public Property Get WindowList() As Boolean
    
    WindowList = m_WindowList

End Property

Friend Property Let WindowList(ByVal v_Data As Boolean)
        
    m_WindowList = v_Data
    
End Property

' Keyboard accelerators collection property

Public Property Get Accelerators() As AccelCol
    
    If Not m_Parent Is Nothing Then
        Set Accelerators = m_Accel
    End If

End Property

' Function to set the MENUITEMINFO structure
' from the owning Item's MENUITEMINFO.
' The item's info is valid and updated
' every time the parent item's SetCtrlState or GetCtrlState functions are called.
' This is to ensure that the Submenu has the proper data variables to pass to
' the menu handler when creating new sub items.

Friend Sub SetItemInfo(v_Info As MENUITEMINFO)
    
    CopyMemory m_ItemInfo, v_Info, Len(m_ItemInfo)
    
End Sub

'' Instructs the object to fire the ItemSelect event if the object is delcared 'WithEvents'
'' This function is called when an item is selected by the window subclassing procedure in
'' the m_EnhancedMenu module.

Friend Sub MenuSelectEvent(ByVal wParam As Long)
    Dim v_Menu As MenuItem, v_EnhMenu As EnhancedMenu, v_Submenu As Submenu
    
    Set v_Menu = SearchRecursive(Me, wParam)
    
    On Error Resume Next
    
    If Not v_Menu Is Nothing Then
            
        If m_Parent Is Nothing Then
            
            RaiseEvent ItemSelect(v_Menu)
        
        Else
            
            If TypeOf m_Parent Is EnhancedMenu Then
                
                Set v_EnhMenu = m_Parent
                v_EnhMenu.MenuSelectEvent wParam
            
            ElseIf TypeOf m_Parent Is Submenu Then
                
                Set v_Submenu = m_Parent
                v_Submenu.MenuSelectEvent wParam
            
            End If
        End If
    
    End If
End Sub

Public Function Add(ByVal sCaption As String, Optional Picture As StdPicture, Optional ByVal sKey As String, Optional ByVal InsertAfter As Variant = -1, Optional ByVal WindowListhWnd As Long = 0&) As MenuItem
    On Error Resume Next
    
    Dim x As MENUITEMINFO, vFlags As Long, xStr As String
    Dim vNewItem As New MenuItem, m_InsertAfter As MenuItem
    Dim v_spHandle As Long
    
    x.cbSize = Len(x)
        
    If m_MenuId = 0 Then Exit Function
    
    ''' Create this menu as necessary...
    
    If m_hMenu = 0 Then Create
                
        ''' If this is a sub menu, we need to tell the parent
        ''' menu that this item now links to a sub menu.
    
    If (Not m_Parent Is Nothing) Then
        m_ItemInfo.fMask = MIIM_SUBMENU + MIIM_ID + MIIM_TYPE
            
        m_ItemInfo.fType = MFT_OWNERDRAW
        m_ItemInfo.dwTypeData = m_Parent.Handle
        m_ItemInfo.wID = m_MenuId
        m_ItemInfo.hSubMenu = m_hMenu
            
        SetMenuItemInfo m_Parent.Handle, m_MenuId, False, m_ItemInfo
    End If
        
    ''' Set the parent of the new item to this instance.
    
    Set vNewItem.Parent = Me
    
    ''' If there is no key, it is the hexidecimal value of the control id.
    
    ''' Menu items are strings. :)  '' Owner drawn
    
    vFlags = MF_OWNERDRAW
    
    ''' Use the old AppendMenu to quickly add a menu item.
    
    If VarType(InsertAfter) = vbString Then
        
        Set m_InsertAfter = Item(InsertAfter)
    
    Else
        
        If InsertAfter <> -1 Then
            Set m_InsertAfter = SearchRecursive(Me, InsertAfter)
        End If
    
    End If
    
    v_spHandle = SuperParent.Handle
    
    ''' Add the item to the collection
    
    If (WindowListhWnd <> 0&) And (m_WindowList = True) Then
                
        If g_WindowList Is Nothing Then
            Set g_WindowList = New Collection
        End If
        
        If WindowListhWnd > 0 Then
            vNewItem.MenuId = WindowListhWnd
        End If
        
        If sKey = "" Then
            vNewItem.Key = "H" + Hex(vNewItem.MenuId)
        Else
            vNewItem.Key = sKey
        End If
    
        g_WindowList.Add vNewItem, vNewItem.Key
    
    Else
    
        If sKey = "" Then
            vNewItem.Key = "H" + Hex(vNewItem.MenuId)
        Else
            vNewItem.Key = sKey
        End If
    
        m_Col.Add vNewItem, vNewItem.Key
        
    End If
            
    If Not m_InsertAfter Is Nothing Then
    
        InsertMenu m_hMenu, m_InsertAfter.MenuId, 0, CLng(vNewItem.MenuId), v_spHandle
        
    Else
        
        AppendMenu m_hMenu, vFlags, CLng(vNewItem.MenuId), v_spHandle
        
    End If
    
    ''' Now set the item's properties so that they are picked up
    ''' by the physical control...
    
    vNewItem.Caption = sCaption
    vNewItem.ClearHighlight = False
    
    If Not Picture Is Nothing Then
        Set vNewItem.Picture = Picture
    End If
    
    Set Add = vNewItem
    Set vNewItem = Nothing
    
End Function

Public Property Get Item(varIndexKey As Variant) As MenuItem
Attribute Item.VB_UserMemId = 0
        
        On Error Resume Next
    
    Select Case VarType(varIndexKey)
    
        Case vbString
        
            If Not m_Col(varIndexKey) Is Nothing Then
                
                Set Item = m_Col(varIndexKey)
                Exit Property
            
            ElseIf m_WindowList = True Then
                
                If Not g_WindowList(varIndexKey) Is Nothing Then
                    Set Item = g_WindowList(varIndexKey)
                    Exit Property
                End If
            
            End If
        
        Case vbLong, vbInteger, vbByte
        
            If Not m_Col(varIndexKey) Is Nothing Then
                
                Set Item = m_Col(varIndexKey)
                Exit Property
                
            ElseIf m_WindowList = True Then
            
                If varIndexKey <= 0 Then Exit Property
                
                If Not g_WindowList(varIndexKey - m_Col.Count) Is Nothing Then
                    
                    Set Item = g_WindowList(varIndexKey - m_Col.Count)
                    Exit Property
                    
                End If
                
            End If
            
    End Select
                            
    Set Item = Nothing
                
End Property

Public Property Get Count() As Long
    On Error Resume Next
    
    If m_WindowList = True Then
        Count = m_Col.Count + g_WindowList.Count
    Else
        Count = m_Col.Count
    End If
    
End Property

Public Sub Remove(varIndexKey As Variant)
    Select Case VarType(varIndexKey)
    
        Case vbString
        
            If Not m_Col(varIndexKey) Is Nothing Then
                
                m_Col.Remove varIndexKey
            
            ElseIf m_WindowList = True Then
                
                If Not g_WindowList(varIndexKey) Is Nothing Then
                    
                    g_WindowList.Remove varIndexKey
                
                End If
                
            End If
        
        Case vbLong, vbInteger, vbByte
        
            If Not m_Col(varIndexKey) Is Nothing Then
               
               m_Col.Remove varIndexKey
                
            ElseIf m_WindowList = True Then
            
                If varIndexKey <= 0 Then Exit Sub
                
                If Not g_WindowList(varIndexKey - m_Col.Count) Is Nothing Then
                    
                    g_WindowList.Remove varIndexKey - m_Col.Count
                
                End If
                
            End If
            
    End Select

End Sub

'' Destroy all sub menus and create a new collection

''' Destroy the sub menus first, or we will generate an exception.
''' You must destroy the menus before terminating the class.

Public Sub Clear()
    Dim v_Item As MenuItem
    
    On Error Resume Next
    
    If m_Col.Count > 0 Then
    
        For Each v_Item In m_Col
            v_Item.Destroy
        Next v_Item
           
        Set m_Col = New Collection
    
    End If
    
End Sub

Public Sub WindowListClear()
    Dim v_Item As MenuItem
    
    If g_WindowList.Count > 0 Then
    
        For Each v_Item In g_WindowList
            v_Item.Destroy
        Next v_Item
           
        Set g_WindowList = New Collection
    
    End If
    
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = m_Col.[_NewEnum]
End Property

Friend Property Get Col() As Collection
    Set Col = m_Col
End Property
        
Friend Property Get WindowListCol() As Collection
    Set WindowListCol = g_WindowList
End Property

'' Search method passes values on to the global SearchRecursive routine

Public Function Search(varIndexKey As Variant) As MenuItem

    Set Search = SearchRecursive(Me, varIndexKey)
    
End Function

'' Method to cause this object to take over the drawing responsibilities
'' for an existing menu.  This object becomes, then, an 'interface' to that
'' menu, and the internal m_hMenu identifier is changed to the menu that is
'' being subclassed.

Public Sub Subclass(ByVal hMenu As Long)
    On Error Resume Next
    
    Dim v_Item As MenuItem, v_Sub As Submenu
    Dim i_Count As Long, i As Long
    Dim v_Info As MENUITEMINFOSTRING, v_Str As String
    Dim Flags As Long, vl_Info As MENUITEMINFO

    Dim j As Integer, s As String

    '' Here is a case where we want our menu destroyed completely, first.
    
    Destroy
        
    m_hMenu = hMenu
    
    CopyMenuToObject Me, hMenu, True
    
    If g_MenuCol("H" + Hex(m_hMenu)) Is Nothing Then
        g_MenuCol.Add Me, "H" + Hex(m_hMenu)
    End If
        
End Sub

Public Sub CopyMenu(ByVal hMenu As Long)

    CopyMenuToObject Me, hMenu
    
End Sub


''' Method to display the menu as a popup menu

Public Sub Popup(Optional ByVal v_hWnd As Long = 0)
    Dim v_xy As POINTAPI, v_RECT As RECT  ' dummy rect for ignored variable.
    
    GetCursorPos v_xy

    If m_hMenu = 0 Then Exit Sub
    
    ' no way to track a popup menu without a window to handle
    ' the callbacks.
    
    If TypeOf SuperParent Is EnhancedMenu Then
        If (v_hWnd = 0) And (SuperParent.hwnd = 0) Then
            Exit Sub
        End If
    
    ElseIf v_hWnd = 0 Then
        Exit Sub
        
    End If
        
    ' if the user chooses to pass an hWnd at the procedure, we process that one
    ' even if the superparent has a window.  To use the superparent window handle,
    ' the developer should call Popup without any arguments.
    
    If Not v_hWnd = 0 Then
        
        TrackPopupMenu m_hMenu, 0, v_xy.x, v_xy.y, 0, v_hWnd, v_RECT
    
    Else
    
        ' TrackPopupMenu is the windows API for opening a menu handle
        ' created as a Submenu/popupmenu... as a popup menu.
        
        ' v_RECT is ignored.
        
        TrackPopupMenu m_hMenu, 0, v_xy.x, v_xy.y, 0, SuperParent.hwnd, v_RECT
    
    End If
    
End Sub

'' Destroy is called internally by the Class_Terminate and Subclass Methods
'' It also can be called externally (e.g. when an error has occured, or to quickly
'' delete the menu without having to unload the instance.)

Public Sub Destroy()
    Dim v_Dum As Object
    
            On Error Resume Next
    
    For Each v_Dum In Me
        v_Dum.Destroy
    Next v_Dum
    
    If m_hMenu <> 0 Then
        Set v_Dum = g_MenuCol("H" + Hex(m_hMenu))
        
        If Not v_Dum Is Nothing Then
            g_MenuCol.Remove "H" + Hex(m_hMenu)
        End If
    End If
    
    Clear
    
End Sub

Public Sub Create()
    On Error Resume Next
   
    If m_hMenu <> 0 Then Exit Sub
    
    m_hMenu = CreatePopupMenu
    
    If g_MenuCol("H" + Hex(m_hMenu)) Is Nothing Then
        g_MenuCol.Add Me, "H" + Hex(m_hMenu)
    End If
    
End Sub

'' Private Subroutines called when an instance is created or destroyed

Private Sub Class_Initialize()
    On Error Resume Next
    
    Dim l As Long
    
    Set m_Col = New Collection
        
    Set m_Accel = New AccelCol
    
    ' Create a new global default font object
            
    m_ItemInfo.cbSize = g_InfoSize
    
End Sub

Private Sub Class_Terminate()
    Destroy
    Set m_Col = Nothing
End Sub

