Attribute VB_Name = "m_EnhancedMenu"
''' Enhanced Menu v2.3

''' Global functions and variables

''' Copyright (C) 2000 Nathan Moschkin.
''' All Rights Reserved.

''' Free to copy and distribute, intact.  Give credit to me and anyone else
''' who may edit this code.

''' Please inquire before using any of this code or the DLL control commercially.
''' An OCX version of the menu with added features will be available soon.

''' (OCX w/ designer coming in version 3)

''' E-Mail questions or comments to nmosch@tampabay.rr.com

                
Public Type HANDLEREFSTRUCT

    Proc As Long
    hwnd As Long
    hMenu As Long
    
End Type

Public Type MDICHILDTYPE

    hwnd As Long
    hFrameWnd As Long
    
    hMenu As Long
    
    Caption As String

End Type

Option Explicit

'' State of keystroke received (needs to be global)

Public g_KeyState As Long

'' Window handles collection (for Calling OldWndProc)

Public g_Handles() As HANDLEREFSTRUCT

'' MDI child collection (for refreshing the WindowList menu)

Public g_MDIWindows() As MDICHILDTYPE

'' Current version of Windows

Public g_WinVersion As WindowsVersionConstants

'' Next available CtrlId (menu numeric identifier for WM_DRAWITEM/WM_MEASUREITEM messages)

Private g_CtrlIdNext As Integer

'' Global menu collection

Public g_MenuCol As Collection

'' Global WindowList item collectio

Public g_WindowList As Collection

'' ItemInfo size (depends on the value of g_WinVersion)

Public g_InfoSize As Long

'' Item identifier to the active windowlist menu on an MDI menu.

Public g_WindowListHandle As Long

'' Global default font

Public g_SysFont As StdFont

'' For each thread of the DLL, the Main() sub is invoked to initialize
'' global data.

Public Sub Main()
    On Error Resume Next

    GetWinVersion
    Set g_MenuCol = New Collection
    Set g_WindowList = New Collection
    
    ' Create a new global default font object
    
    Set g_SysFont = GetSystemFont
    
    If g_SysFont Is Nothing Then
        Set g_SysFont = New StdFont
        g_SysFont.Size = 8
        g_SysFont.Name = "MS Sans Serif"
    End If
    
    g_CtrlIdNext = &H128
    
End Sub

Public Function KeyCodeToItem(ByVal hwnd As Long, ByVal uKeyCode As Integer, ByVal uState As Long) As MenuItem
    On Error Resume Next
    
    Dim x As Object, y As MenuItem
    Dim xWnd As Long
    
    For Each x In g_MenuCol
            
        xWnd = x.SuperParent.hwnd
        
        If (xWnd = hwnd) Then
            For Each y In x
            
                If y.Accelerator.Key = uKeyCode Then
                    If y.Accelerator.fVirt = uState Then
                        Set KeyCodeToItem = y
                        Exit Function
                    End If
                End If
            
            Next y
        End If
        
    Next x
    
End Function


''' Get a new control ID for the menu interface from the global pool.

Public Function GetNewCtrlId() As Integer
    
    If g_CtrlIdNext = 0 Then
        g_CtrlIdNext = &H1248
    End If
                
    GetNewCtrlId = g_CtrlIdNext
    '' Increment the control ID.
    g_CtrlIdNext = g_CtrlIdNext + 1
            
End Function

Public Function CmdBySelector(ByVal sSelector As String, m_Menu As Object) As Long
    On Error Resume Next
    
    Dim v As MenuItem, v_index As Long
    
    Dim r As Submenu
    
    If TypeOf m_Menu Is Submenu Then
        Set r = m_Menu
        For Each v In r
            If v.Accelerator.Selector = UCase(sSelector) Then
                CmdBySelector = v_index
                Exit Function
            End If
            v_index = v_index + 1
        Next v
    Else
        For Each v In m_Menu
            If v.Accelerator.Selector = UCase(sSelector) Then
                CmdBySelector = v_index
                Exit Function
            End If
            v_index = v_index + 1
        Next v
    End If
    CmdBySelector = -1&
    
End Function


Public Function AccelCodeToString(ByVal fVirt As Byte, Key As Integer) As String

    Dim sAccel As String
    
    If (fVirt And FSHIFT) Then
        sAccel = "Shift+"
    End If
    
    If (fVirt And FCONTROL) Then
        sAccel = sAccel + "Ctrl+"
    End If
        
    Select Case Key
                    
        Case vbKeyF1 To vbKeyF16:
            sAccel = sAccel + "F" + Format(Key - 111)
        
        Case vbKeyMenu:
            sAccel = sAccel + "Menu"
        
        Case vbKeyCapital:
            sAccel = sAccel + "CapsLock"
        
        Case vbKeySpace:
            sAccel = sAccel + "SpaceBar"
        
        Case vbKeyNumlock:
            sAccel = sAccel + "Numlock"
        
        Case vbKeyPrint:
            sAccel = sAccel + "Print"
        
        Case vbKeyInsert:
            sAccel = sAccel + "Insert"
        
        Case vbKeyHelp:
            sAccel = sAccel + "Help"
        
        Case vbKeyDelete:
            sAccel = sAccel + "Delete"
            
        Case 48 To 57, 65 To 90
            sAccel = sAccel + Chr(Key)
            
    End Select
    
    AccelCodeToString = sAccel

End Function

Public Sub StringToAccelCode(ByVal sAccel As String, aAccel As ACCEL)

    Dim s_Token As String, keyCode As Integer
    
    s_Token = StrTok(sAccel, "+")
                
    Do While s_Token <> ""
        keyCode = Asc(s_Token)
        
        Select Case s_Token
            Case "Shift":
                aAccel.fVirt = aAccel.fVirt + FSHIFT
                
            Case "Ctrl":
                aAccel.fVirt = aAccel.fVirt + FCONTROL
                
            Case "Alt":
            ' Can't use alt.
        
            Case "F1", "F2", "F3", "F4", "F5", "F6", "F7", _
                 "F8", "F9", "F10", "F11", "F12", "F13", "F14", "F15", "F16"
                
                aAccel.Key = aAccel.Key + (Val(Mid(s_Token, 2)) + 111)
        
            Case "Menu"
                aAccel.Key = aAccel.Key + vbKeyMenu
        
            Case "CapsLock"
                aAccel.Key = aAccel.Key + vbKeyCapital
        
            Case "SpaceBar"
                aAccel.Key = aAccel.Key + vbKeySpace
        
            Case "Numlock"
                aAccel.Key = aAccel.Key + vbKeyNumlock
        
            Case "Print"
                aAccel.Key = aAccel.Key + vbKeyPrint
        
            Case "Insert"
                aAccel.Key = aAccel.Key + vbKeyInsert
        
            Case "Help"
                aAccel.Key = aAccel.Key + vbKeyHelp
            
            Case "Delete"
                aAccel.Key = aAccel.Key + vbKeyDelete
        
            Case Else
            
                Select Case keyCode
                    
                    Case 48 To 57, 65 To 90
                        aAccel.Key = aAccel.Key + keyCode
                        
                End Select
        
        End Select
        s_Token = StrTok(vbNullString, "+")
    
    Loop
    
End Sub

Public Function AddHandle(ByVal hwnd As Long, ByVal Proc As Long, Optional ByVal h_Menu As Long)
    On Error Resume Next
    
    Dim x As Long

    x = -1
    x = UBound(g_Handles)
    
    If x = -1 Then
        ReDim g_Handles(0)
        x = 0
    Else
        x = x + 1
        ReDim Preserve g_Handles(x)
    End If
    
    With g_Handles(x)
        .hwnd = hwnd
        .Proc = Proc
        .hMenu = h_Menu
    End With
    
End Function


Public Function RemoveHandle(ByVal hwnd As Long)
    On Error Resume Next

    Dim x As Long, y As Boolean
    
    x = -1
    x = UBound(g_Handles)
    
    If x = -1 Then Exit Function
    
    For x = LBound(g_Handles) To UBound(g_Handles)
    
        If g_Handles(x).hwnd = hwnd Then
        
            y = True
        End If
    
    
        If y = True Then
            
            If (x + 1) <= UBound(g_Handles) Then
                CopyMemory g_Handles(x), g_Handles(x + 1), Len(g_Handles(x))
            Else
                If (x - 1) >= 0 Then
                    ReDim Preserve g_Handles(x - 1)
                Else
                    Erase g_Handles
                End If
                
                Exit For
            End If
        End If
        
    Next x
    
End Function

Public Function GetMenuByHandle(ByVal hwnd As Long) As EnhancedMenu
    On Error Resume Next

    Dim x As Long, y As Boolean
    
    x = -1
    x = UBound(g_Handles)
    
    If x = -1 Then Exit Function
    
    For x = LBound(g_Handles) To UBound(g_Handles)
    
        If g_Handles(x).hwnd = hwnd Then
            Set GetMenuByHandle = g_MenuCol("H" + Hex(g_Handles(x).hMenu))
            Exit Function
        End If
        
    Next x
    
End Function

Public Function GetFrameWnd(ByVal hwnd As Long) As Long
    On Error Resume Next

    Dim x As Long, y As Boolean
    
    x = -1
    x = UBound(g_MDIWindows)
    
    If x = -1 Then Exit Function
    
    For x = LBound(g_MDIWindows) To UBound(g_MDIWindows)
    
        If g_MDIWindows(x).hwnd = hwnd Then
            GetFrameWnd = g_MDIWindows(x).hFrameWnd
            Exit Function
        End If
        
    Next x
    
End Function

Public Sub GetWinVersion()

    Dim pData As OSVERSIONINFO, m_ItemInfo As MENUITEMINFO
    
    pData.OSVersionInfoSize = Len(pData)
    
    GetVersion pData
    
    g_WinVersion = (pData.MajorVersion * 100) + pData.MinorVersion

    Select Case g_WinVersion
    
        Case Windows2000:
            g_InfoSize = Len(m_ItemInfo)
        
        Case Else
            g_InfoSize = Len(m_ItemInfo) - 4
    
    End Select

End Sub

Public Function WinVerString() As String

    Dim pData As OSVERSIONINFO
    Dim v_Str As String
    
    pData.OSVersionInfoSize = Len(pData)
    
    GetVersion pData
        
    g_WinVersion = (pData.MajorVersion * 100) + pData.MinorVersion
    
    v_Str = "Windows "
    
    Select Case g_WinVersion
    
        Case Windows95:
            v_Str = v_Str + "95"
        Case Windows98:
            v_Str = v_Str + "95"
        Case WindowsNT:
            v_Str = v_Str + "NT"
        Case WindowsME:
            v_Str = v_Str + "Millennium"
        Case Windows2000:
            v_Str = v_Str + "2000"
        Case Is > Windows2000:
            v_Str = v_Str + "2000 or better -"
    End Select
    
    With pData
    
        If InStr(1, .CSDVersion, Chr(0)) Then
            .CSDVersion = Mid(.CSDVersion, 1, InStr(1, .CSDVersion, Chr(0)) - 1)
        End If
        v_Str = v_Str + " " + .CSDVersion
    
    End With
    
    WinVerString = v_Str
    
End Function

Public Function GetClientWindow(ByVal hWndFrame As Long) As Long
    
    RefreshChildWindows hWndFrame
    GetClientWindow = g_MDIWindows(0).hwnd

End Function

Public Function EnumChildWndProc(ByVal hwnd As Long, lParam As Long) As Long

    AddMDIChild hwnd, lParam
    EnumChildWndProc = True
   
End Function

Public Sub RefreshChildWindows(ByVal hWndFrame As Long)
    Dim v_Var As Long
    
    Erase g_MDIWindows
    
    v_Var = hWndFrame
    EnumChildWindows hWndFrame, AddressOf EnumChildWndProc, v_Var
    
End Sub

Public Function GetMDIFrame(ByVal hwnd As Long) As Long
    On Error Resume Next

    Dim x As Long
    
    x = -1
    x = UBound(g_MDIWindows)
    
    If x = -1 Then Exit Function
    
    For x = LBound(g_MDIWindows) To UBound(g_MDIWindows)
    
        If g_MDIWindows(x).hwnd = hwnd Then
            GetMDIFrame = g_MDIWindows(x).hFrameWnd
            Exit Function
        End If
            
    Next x
    GetMDIFrame = 0
    
End Function

Public Function UpdateMDICaptions()
    On Error Resume Next
    
    Dim i As Long
    Dim vs_Caption As String
    
    i = -1
    i = LBound(g_MDIWindows)
    
    If i < 0 Then Exit Function
    
    For i = LBound(g_MDIWindows) To UBound(g_MDIWindows)
    
        With g_MDIWindows(i)
            vs_Caption = String(257, 0)
            GetWindowText .hwnd, vs_Caption, 256
            vs_Caption = Mid(vs_Caption, 1, InStr(1, vs_Caption, Chr(0)) - 1)
    
            .Caption = vs_Caption
        End With
    
    Next i
        
End Function

Public Function AddMDIChild(ByVal hwnd As Long, ByVal hFrameWnd As Long, Optional ByVal h_Menu As Long)

    On Error Resume Next
    
    Dim x As Long
    Dim vs_Caption As String
        
    vs_Caption = String(257, 0)
    GetWindowText hwnd, vs_Caption, 256
    vs_Caption = Mid(vs_Caption, 1, InStr(1, vs_Caption, Chr(0)) - 1)
    
    x = -1
    x = UBound(g_MDIWindows)
    
    If x = -1 Then
        ReDim g_MDIWindows(0)
        x = 0
    Else
        x = x + 1
        ReDim Preserve g_MDIWindows(x)
    End If
    
    With g_MDIWindows(x)
    
        .hwnd = hwnd
        .hMenu = h_Menu
        .hFrameWnd = hFrameWnd
        
        .Caption = vs_Caption
        
    End With
    
End Function

Public Sub RemoveMDIChild(ByVal hwnd As Long)
    On Error Resume Next

    Dim x As Long, y As Boolean
    
    x = -1
    x = UBound(g_MDIWindows)
    
    If x = -1 Then Exit Sub
    
    For x = LBound(g_MDIWindows) To UBound(g_MDIWindows)
    
        If g_MDIWindows(x).hwnd = hwnd Then
        
            y = True
        End If
    
    
        If y = True Then
            
            If (x + 1) <= UBound(g_MDIWindows) Then
                CopyMemory g_MDIWindows(x), g_MDIWindows(x + 1), Len(g_MDIWindows(x))
            Else
                If (x - 1) >= 0 Then
                    ReDim Preserve g_MDIWindows(x - 1)
                Else
                    Erase g_MDIWindows
                End If
                
                Exit For
            End If
        End If
        
    Next x

End Sub

'' Method to copy the contents of another menu into this one

Public Function CopyMenuToObject(vDest As Object, ByVal hMenu As Long, Optional ByVal Subclass As Boolean = False)
    On Error Resume Next
    
    Dim v_Item As MenuItem, v_Submenu As Submenu, v_Col As Collection
    Dim v_hMenu As Long, v_Menu As EnhancedMenu
    
    Dim v_Info As MENUITEMINFOSTRING, vl_Info As MENUITEMINFO
    
    Dim v_Count As Long
    Dim v_Flags As Long
    Dim v_GoodTypes As Long

    Dim v_Str2 As String, v_Str1 As String
    
    Dim j As Integer, i As Integer
    
    If (Not TypeOf vDest Is EnhancedMenu) And (Not TypeOf vDest Is Submenu) Then Exit Function
    
    vDest.Clear
    
    If (Not Subclass) Then
        If (vDest.Handle = 0) Then
            vDest.Create
        End If
        v_hMenu = vDest.Handle
    Else
        v_hMenu = hMenu
    End If
    
    v_Count = GetMenuItemCount(hMenu)
    
    For i = 0 To v_Count - 1
        
        v_Info.cch = 255
        v_Info.dwTypeData = String(256, 0)
        
        v_Info.cbSize = g_InfoSize
        v_Info.fMask = MIIM_SUBMENU + MIIM_TYPE + MIIM_STATE + MIIM_ID
        
        GetMenuItemInfoStr hMenu, i, True, v_Info
        CopyMemory vl_Info, v_Info, Len(vl_Info)
        
        v_GoodTypes = MFT_STRING Or MFT_OWNERDRAW Or MFT_SEPARATOR Or MFT_MENUBARBREAK Or MFT_MENUBREAK Or MFT_RIGHTJUSTIFY
        
        If (v_Info.fType And v_GoodTypes) Or (v_Info.fType = 0) Then
            
            Set v_Item = New MenuItem
            
            If Subclass Then
                v_Info.wID = v_Item.MenuId
                vl_Info.wID = v_Info.wID
                vl_Info.fMask = MIIM_ID
                SetMenuItemInfo hMenu, i, True, vl_Info
            End If
            
            Set v_Item.Parent = vDest
            
            If (v_Info.fType And MFT_OWNERDRAW) Or (v_Info.fType = 0) Then
                
                If (v_Info.dwTypeData = "") And (vl_Info.dwTypeData <> CLng(vDest.SuperParent.Handle)) Then
                    
                    v_Str1 = "-"
                
                ElseIf (vl_Info.dwTypeData <> vDest.SuperParent.Handle) Then
                    v_Str1 = Mid(v_Info.dwTypeData, 1, InStr(1, v_Info.dwTypeData, Chr(0)) - 1)
                    j = InStr(1, v_Str1, Chr(9))
                    
                    If j <> 0 Then
                        v_Str2 = Mid(v_Str1, j + 1)
                        v_Str1 = Mid(v_Str1, 1, j - 1)
                        v_Item.Accelerator.AccelWord = v_Str2
                    End If
                        
                Else
                    
                    Set v_Item = Nothing
                    Set v_Item = vDest.Search(v_Info.wID)
                
                End If
                
            ElseIf (v_Info.fType And MFT_SEPARATOR) Then
                
                v_Str1 = "-"
            
            Else
                
                v_Str1 = vbNullString
            
            End If
                        
            v_GoodTypes = (MFT_MENUBARBREAK Or MFT_MENUBREAK)
            
            If (v_Info.fType And v_GoodTypes) Then
            
                v_Flags = v_Info.fType And v_GoodTypes
            
            Else
                
                v_Flags = MFT_OWNERDRAW Or (v_Info.fType And MFT_RIGHTJUSTIFY)
            
            End If
            
            v_Info.fType = v_Flags
            vl_Info.fType = v_Flags
            
            If Not Subclass Then
                AppendMenu v_hMenu, v_Flags, v_Item.MenuId, v_hMenu
            End If
                        
            v_Item.Caption = v_Str1
            v_Item.Checked = CBool(v_Info.fState And MFS_CHECKED)
            v_Item.Default = CBool(v_Info.fState And MFS_DEFAULT)
            v_Item.Enabled = CBool((v_Info.fState And MFS_DISABLED) Xor MFS_DISABLED)
            
            v_Item.BarBreak = CBool(v_Info.fType And MFT_MENUBARBREAK)
            v_Item.Break = CBool(v_Info.fType And MFT_MENUBREAK)
            v_Item.RightJustify = CBool(v_Info.fType And MFT_RIGHTJUSTIFY)
                        
            v_Item.Key = "ID_" + Hex(v_Item.MenuId)
            
            If TypeOf vDest Is EnhancedMenu Then
                
                Set v_Menu = vDest
                v_Menu.Col.Add v_Item, v_Item.Key
            
            ElseIf TypeOf vDest Is Submenu Then
            
                Set v_Submenu = vDest
                v_Submenu.Col.Add v_Item, v_Item.Key
            
            End If
                        
            If (vl_Info.hSubMenu <> 0) Then
                            
                If Not Subclass Then
                    v_Item.Submenu.Create
                Else
                    v_Item.Submenu.Handle = v_Info.hSubMenu
                End If
                
                CopyMenuToObject v_Item.Submenu, v_Info.hSubMenu, Subclass
                
                If Not Subclass Then
                
                    vl_Info.fMask = MIIM_SUBMENU
                    vl_Info.hSubMenu = v_Item.Submenu.Handle
                    vl_Info.wID = v_Item.MenuId
                
                    SetMenuItemInfo v_hMenu, vl_Info.wID, False, vl_Info
                End If
            
            End If
                        
        End If
    
    Next i
        
    If (TypeOf vDest Is EnhancedMenu) Then
        vDest.Accelerators.MakeTable vDest
    
    ElseIf (vDest.Parent Is Nothing) Then
        vDest.Accelerators.MakeTable vDest
    
    End If
    
End Function

Public Function StringFromPointer(ByVal lPtr As Long) As String

    Dim i As Long
    Dim b As Byte
    
    Dim s As String
    
    CopyMemory b, lPtr, 1
    
    Do While Not b = 0
    
        s = s + Chr(b)
        CopyMemory b, lPtr + i, 1
        
    Loop

    StringFromPointer = s

End Function

Public Function GetSystemFont() As StdFont
    Dim v_NCLI As NONCLIENTMETRICS
    
    v_NCLI.cbSize = Len(v_NCLI)
    SystemParametersInfo SPI_GETNONCLIENTMETRICS, Len(v_NCLI), v_NCLI, 0&
    
    Set GetSystemFont = GetIFont(v_NCLI.lfMenuFont)
        
End Function


